﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exc;



    namespace Jonson
    {
        public class ZadachaJohnsonaV //считывание из файла
    {
        private string filePer;
        private List<string> DataFromFiles;

        public ZadachaJohnsonaV(string filePer1)
        {
                filePer = filePer;//что будет передаваться в файл
            DataFromFiles = File.ReadAllLines(@filePer).ToList();
        }

        public ZadachaJohnsona CreateZadachaJohnsona() => new ZadachaJohnsona(DataFromFiles.ConvertAll(x => new Detali(x.Split(";")))); //экземпляр метода
        }
    public struct Detali
    {
        public int Time1;// Время за которое обрабатываются детали на 1 станке
        public int Time2;// Время за которое обрабатываются детали на 2 станке
        public Detali(string[] TimeD)
        {
            Time1 = Convert.ToInt32(TimeD[0]);
            Time2 = Convert.ToInt32(TimeD[1]);
        }
        public int MinimTimPross
        {
            get => (Time1 < Time2) ? Time1 : Time2;
        }
        public int SummaTimePross
        {
            get => (Time1 + Time2);
        }
    }
    public class ZadachaJohnsona
    {
        /// <summary>
        /// Детали, не отосортированныйе
        /// </summary>
        private List<Detali> NoSortDa;

        /// <summary>
        /// Оптимальное распределение деталей
        /// </summary>
        private List<Detali> YesSortDa;

        public ZadachaJohnsona(List<Detali> NoSortD)
        {
            NoSortDa = NoSortD;
            YesSortDa = new List<Detali>();
        }

        public int SpeedObr()
        {
            List<Detali> NoSortDSpeedPross1 = new(); //Список деталей быстрее обрабатывающихся на 1 станке
            List<Detali> NoSortDSpeedPross2 = new(); //Список деталей быстрее обрабатывающихся на 2 станке
            FirstStepOfSorting(NoSortDSpeedPross1, NoSortDSpeedPross2); //Разделение несортированного массива на 2
            SecondStepOfSorting(NoSortDSpeedPross1, 1);
            SecondStepOfSorting(NoSortDSpeedPross2, 2);
            NoSortDSpeedPross1.ForEach(x => YesSortDa.Add(x));
            NoSortDSpeedPross2.ForEach(x => YesSortDa.Add(x));
            Console.WriteLine($"Время простоя  = {CalculTime()}");
            return CalculTime();
        }

        /// <summary>
        /// Метод разделения не сортированного массива на два, где в первом находятся детали быстрее обрабатывающиеся на 1 станке, а во втором, быстрее обрабатывающиеся на 2
        /// </summary>
        /// <param name="DetalObr1">Список деталей быстрее обрабатывающихся на 1 станке</param>
        /// <param name="DetalObr2">Список деталей быстрее обрабатывающихся на 2 станке</param>
        public void FirstStepOfSorting(List<Detali> DetalObr1, List<Detali> DetalObr2)
        {
            foreach (var detal in NoSortDa)
            {
                if (detal.Time1 < detal.Time2) DetalObr1.Add(detal);
                else DetalObr1.Add(detal);
            }
        }

        /// <summary>
        /// Метод для сортировки деталей внутри контейнера, отсортированного по скорости
        /// </summary>
        public void SecondStepOfSorting(List<Detali> notSortedList, int Nude)//1 - список деталей быстрее обрабатывающихся на 1, 2 - спсиок деталей быстрее обрабатывающихся на 2
        {
            if (Nude == 1) //Сортирование деталей быстрее обрабатывающихся на 1 станке
            {
                bool Flag = true;
                while (Flag)
                {
                    Flag = false;
                    for (int NumberOfDetal = 0; NumberOfDetal < notSortedList.Count - 1; NumberOfDetal++)
                    {
                        if (notSortedList[NumberOfDetal].MinimTimPross > notSortedList[NumberOfDetal + 1].MinimTimPross)
                        {
                            Flag = true;
                            Detali DetalForSwap = notSortedList[NumberOfDetal];
                            notSortedList[NumberOfDetal] = notSortedList[NumberOfDetal + 1];
                            notSortedList[NumberOfDetal + 1] = DetalForSwap;
                        }
                        else if (notSortedList[NumberOfDetal].MinimTimPross == notSortedList[NumberOfDetal + 1].MinimTimPross && notSortedList[NumberOfDetal].SummaTimePross < notSortedList[NumberOfDetal + 1].SummaTimePross)
                        {
                            Flag = true;
                            Detali DetalForSwap = notSortedList[NumberOfDetal];
                            notSortedList[NumberOfDetal] = notSortedList[NumberOfDetal + 1];
                            notSortedList[NumberOfDetal + 1] = DetalForSwap;
                        }
                    }
                }
            }
            if (Nude == 2) //Сортирование деталей быстрее обрабатывающихся на 2 станке
            {
                bool Flag = true;
                while (Flag)
                {
                    Flag = false;
                    for (int NumberOfDetal = 0; NumberOfDetal < notSortedList.Count - 1; NumberOfDetal++)
                    {
                        if (notSortedList[NumberOfDetal].SummaTimePross < notSortedList[NumberOfDetal + 1].SummaTimePross)
                        {
                            Flag = true;
                            Detali DetalForSwap = notSortedList[NumberOfDetal];
                            notSortedList[NumberOfDetal] = notSortedList[NumberOfDetal + 1];
                            notSortedList[NumberOfDetal + 1] = DetalForSwap;
                        }
                        else if (notSortedList[NumberOfDetal].MinimTimPross == notSortedList[NumberOfDetal + 1].MinimTimPross && notSortedList[NumberOfDetal].SummaTimePross > notSortedList[NumberOfDetal + 1].SummaTimePross)
                        {
                            Flag = true;
                            Detali DetalForSwap = notSortedList[NumberOfDetal];
                            notSortedList[NumberOfDetal] = notSortedList[NumberOfDetal + 1];
                            notSortedList[NumberOfDetal + 1] = DetalForSwap;
                        }
                    }
                }
            }
        }

        /// <summary>
        /// Метод расчета времени простоя
        /// </summary>
        /// <returns>время простоя</returns>
        public int CalculTime()
        {
            List<int> FreeTimes = new List<int>();
            for (int numberOfDetail = 0; numberOfDetail < YesSortDa.Count; numberOfDetail++)
            {
                if (numberOfDetail == 0) FreeTimes.Add(YesSortDa[0].Time1);
                else FreeTimes.Add(FreeTimes[numberOfDetail - 1] +
                    YesSortDa[numberOfDetail].Time1 -
                    YesSortDa[numberOfDetail - 1].Time2);
            }
            return FreeTimes.Max();
        }

        internal void FindSolution()
        {
            throw new NotImplementedException();
        }
    }
}
    }
